xref: /openbmc/linux/scripts/kconfig/Makefile (revision c5254e72)
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
5PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
6	localmodconfig localyesconfig
7
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
11Kconfig := Kconfig
12endif
13
14ifeq ($(quiet),silent_)
15silent := -s
16endif
17
18# We need this, in case the user has it in its environment
19unexport CONFIG_
20
21xconfig: $(obj)/qconf
22	$< $(silent) $(Kconfig)
23
24gconfig: $(obj)/gconf
25	$< $(silent) $(Kconfig)
26
27menuconfig: $(obj)/mconf
28	$< $(silent) $(Kconfig)
29
30config: $(obj)/conf
31	$< $(silent) --oldaskconfig $(Kconfig)
32
33nconfig: $(obj)/nconf
34	$< $(silent) $(Kconfig)
35
36silentoldconfig: $(obj)/conf
37	$(Q)mkdir -p include/config include/generated
38	$(Q)test -e include/generated/autoksyms.h || \
39	    touch   include/generated/autoksyms.h
40	$< $(silent) --$@ $(Kconfig)
41
42localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
43	$(Q)mkdir -p include/config include/generated
44	$(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
45	$(Q)if [ -f .config ]; then 					\
46			cmp -s .tmp.config .config ||			\
47			(mv -f .config .config.old.1;			\
48			 mv -f .tmp.config .config;			\
49			 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
50			 mv -f .config.old.1 .config.old)		\
51	else								\
52			mv -f .tmp.config .config;			\
53			$(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
54	fi
55	$(Q)rm -f .tmp.config
56
57# Create new linux.pot file
58# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
59update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
60	$(Q)$(kecho) "  GEN     config.pot"
61	$(Q)xgettext --default-domain=linux                         \
62	    --add-comments --keyword=_ --keyword=N_                 \
63	    --from-code=UTF-8                                       \
64	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
65	    --directory=$(srctree) --directory=$(objtree)           \
66	    --output $(obj)/config.pot
67	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
68	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
69	    $(srctree)/arch/*/um/Kconfig`;               \
70	    do                                           \
71		$(kecho) "  GEN     $$i";                    \
72		$(obj)/kxgettext $$i                     \
73		     >> $(obj)/config.pot;               \
74	    done )
75	$(Q)$(kecho) "  GEN     linux.pot"
76	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
77	    --output $(obj)/linux.pot
78	$(Q)rm -f $(obj)/config.pot
79
80# These targets map 1:1 to the commandline options of 'conf'
81simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
82	alldefconfig randconfig listnewconfig olddefconfig
83PHONY += $(simple-targets)
84
85$(simple-targets): $(obj)/conf
86	$< $(silent) --$@ $(Kconfig)
87
88PHONY += oldnoconfig savedefconfig defconfig
89
90# oldnoconfig is an alias of olddefconfig, because people already are dependent
91# on its behavior (sets new symbols to their default value but not 'n') with the
92# counter-intuitive name.
93oldnoconfig: olddefconfig
94
95savedefconfig: $(obj)/conf
96	$< $(silent) --$@=defconfig $(Kconfig)
97
98defconfig: $(obj)/conf
99ifeq ($(KBUILD_DEFCONFIG),)
100	$< $(silent) --defconfig $(Kconfig)
101else
102ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
103	@$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
104	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
105else
106	@$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
107	$(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
108endif
109endif
110
111%_defconfig: $(obj)/conf
112	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
113
114configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
115
116%.config: $(obj)/conf
117	$(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
118	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
119	+$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
120
121PHONY += kvmconfig
122kvmconfig: kvm_guest.config
123	@:
124
125PHONY += xenconfig
126xenconfig: xen.config
127	@:
128
129PHONY += tinyconfig
130tinyconfig:
131	$(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
132
133# Help text used by make help
134help:
135	@echo  '  config	  - Update current config utilising a line-oriented program'
136	@echo  '  nconfig         - Update current config utilising a ncurses menu based'
137	@echo  '                    program'
138	@echo  '  menuconfig	  - Update current config utilising a menu based program'
139	@echo  '  xconfig	  - Update current config utilising a Qt based front-end'
140	@echo  '  gconfig	  - Update current config utilising a GTK+ based front-end'
141	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
142	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
143	@echo  '  localyesconfig  - Update current config converting local mods to core'
144	@echo  '  silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
145	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
146	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
147	@echo  '  allnoconfig	  - New config where all options are answered with no'
148	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
149	@echo  '  allmodconfig	  - New config selecting modules when possible'
150	@echo  '  alldefconfig    - New config with all symbols set to default'
151	@echo  '  randconfig	  - New config with random answer to all options'
152	@echo  '  listnewconfig   - List new options'
153	@echo  '  olddefconfig	  - Same as silentoldconfig but sets new symbols to their'
154	@echo  '                    default value'
155	@echo  '  kvmconfig	  - Enable additional options for kvm guest kernel support'
156	@echo  '  xenconfig       - Enable additional options for xen dom0 and guest kernel support'
157	@echo  '  tinyconfig	  - Configure the tiniest possible kernel'
158
159# lxdialog stuff
160check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
161
162# Use recursively expanded variables so we do not call gcc unless
163# we really need to do so. (Do not call gcc as part of make mrproper)
164HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
165                    -DLOCALE
166
167# ===========================================================================
168# Shared Makefile for the various kconfig executables:
169# conf:	  Used for defconfig, oldconfig and related targets
170# nconf:  Used for the nconfig target.
171#         Utilizes ncurses
172# mconf:  Used for the menuconfig target
173#         Utilizes the lxdialog package
174# qconf:  Used for the xconfig target
175#         Based on Qt which needs to be installed to compile it
176# gconf:  Used for the gconfig target
177#         Based on GTK+ which needs to be installed to compile it
178# object files used by all kconfig flavours
179
180lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
181lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
182
183conf-objs	:= conf.o  zconf.tab.o
184mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
185nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
186kxgettext-objs	:= kxgettext.o zconf.tab.o
187qconf-cxxobjs	:= qconf.o
188qconf-objs	:= zconf.tab.o
189gconf-objs	:= gconf.o zconf.tab.o
190
191hostprogs-y := conf nconf mconf kxgettext qconf gconf
192
193clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
194clean-files	+= zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
195clean-files     += config.pot linux.pot
196
197# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
198PHONY += $(obj)/dochecklxdialog
199$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
200$(obj)/dochecklxdialog:
201	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
202
203always := dochecklxdialog
204
205# Add environment specific flags
206HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
207
208# generated files seem to need this to find local include files
209HOSTCFLAGS_zconf.lex.o	:= -I$(src)
210HOSTCFLAGS_zconf.tab.o	:= -I$(src)
211
212LEX_PREFIX_zconf	:= zconf
213YACC_PREFIX_zconf	:= zconf
214
215HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
216HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
217
218HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
219HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
220                          -Wno-missing-prototypes
221
222HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
223
224HOSTLOADLIBES_nconf	= $(shell \
225				pkg-config --libs menuw panelw ncursesw 2>/dev/null \
226				|| pkg-config --libs menu panel ncurses 2>/dev/null \
227				|| echo "-lmenu -lpanel -lncurses"  )
228$(obj)/qconf.o: $(obj)/.tmp_qtcheck
229
230ifeq ($(MAKECMDGOALS),xconfig)
231$(obj)/.tmp_qtcheck: $(src)/Makefile
232-include $(obj)/.tmp_qtcheck
233
234# Qt needs some extra effort...
235$(obj)/.tmp_qtcheck:
236	@set -e; $(kecho) "  CHECK   qt"; \
237	if pkg-config --exists Qt5Core; then \
238	    cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
239	    libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
240	    moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
241	elif pkg-config --exists QtCore; then \
242	    cflags=`pkg-config --cflags QtCore QtGui`; \
243	    libs=`pkg-config --libs QtCore QtGui`; \
244	    moc=`pkg-config --variable=moc_location QtCore`; \
245	else \
246	    echo >&2 "*"; \
247	    echo >&2 "* Could not find Qt via pkg-config."; \
248	    echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
249	    echo >&2 "*"; \
250	    exit 1; \
251	fi; \
252	echo "KC_QT_CFLAGS=$$cflags" > $@; \
253	echo "KC_QT_LIBS=$$libs" >> $@; \
254	echo "KC_QT_MOC=$$moc" >> $@
255endif
256
257$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
258
259ifeq ($(MAKECMDGOALS),gconfig)
260-include $(obj)/.tmp_gtkcheck
261
262# GTK+ needs some extra effort, too...
263$(obj)/.tmp_gtkcheck:
264	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
265		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
266			touch $@;								\
267		else									\
268			echo >&2 "*"; 							\
269			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
270			echo >&2 "*";							\
271			false;								\
272		fi									\
273	else										\
274		echo >&2 "*"; 								\
275		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
276		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
277		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
278		echo >&2 "*"; 								\
279		false;									\
280	fi
281endif
282
283$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
284
285$(obj)/qconf.o: $(obj)/qconf.moc
286
287quiet_cmd_moc = MOC     $@
288      cmd_moc = $(KC_QT_MOC) -i $< -o $@
289
290$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
291	$(call cmd,moc)
292
293# Extract gconf menu items for i18n support
294$(obj)/gconf.glade.h: $(obj)/gconf.glade
295	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
296	$(obj)/gconf.glade
297